﻿//////////////////////////////////////////////////////////////////////////
//默认账号交易
//策略描述：
//默认账号进行交易，下单时不指定account

using GMSDK;

namespace example_defaccount
{
    public class MyStrategy : Strategy
    {
        public MyStrategy(string token, string strategyId, StrategyMode mode) : base(token, strategyId, mode) { }

        //重写OnInit事件，进行策略开发
        public override void OnInit()
        {
            System.Console.WriteLine("OnInit");
            Subscribe("SHSE.600000,SZSE.000001", "1d");

            return;
        }

        //重写OnBar事件
        public override void OnBar(Bar bar)
        {
            //不指定account 使用默认账户下单
            OrderVolume(bar.symbol, 200, OrderSide.OrderSide_Buy, OrderType.OrderType_Market, PositionEffect.PositionEffect_Open, 0);
        }

        //回测完成，收到绩效报告
        public override void OnBacktestFinished(Indicator indicator)
        {
            System.Console.WriteLine("OnIndicator：");
            System.Console.WriteLine("{0,-50}{1}", "账号ID：", indicator.accountId);
            System.Console.WriteLine("{0,-50}{1}", "累计收益率：", indicator.pnlRatio);
            System.Console.WriteLine("{0,-50}{1}", "年化收益率：", indicator.pnlRatioAnnual);
            System.Console.WriteLine("{0,-50}{1}", "夏普比率：", indicator.sharpRatio);
            System.Console.WriteLine("{0,-50}{1}", "最大回撤：", indicator.maxDrawdown);
            System.Console.WriteLine("{0,-50}{1}", "风险比率：", indicator.riskRatio);
            System.Console.WriteLine("{0,-50}{1}", "开仓次数：", indicator.openCount);
            System.Console.WriteLine("{0,-50}{1}", "平仓次数：", indicator.closeCount);
            System.Console.WriteLine("{0,-50}{1}", "盈利次数：", indicator.winCount);
            System.Console.WriteLine("{0,-50}{1}", "亏损次数：", indicator.loseCount);
            System.Console.WriteLine("{0,-50}{1}", "胜率：", indicator.winRatio);
            System.Console.WriteLine("{0,-50}{1}", "指标创建时间：", indicator.createdAt);
            System.Console.WriteLine("{0,-50}{1}", "指标变更时间：", indicator.updatedAt);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            MyStrategy s = new MyStrategy("{{token}}","{{strategyId}}", StrategyMode.MODE_BACKTEST);
            s.SetBacktestConfig("2016-07-11 17:20:00", "2017-07-11 17:30:00");
            s.Run();
            System.Console.WriteLine("回测完成！");
            System.Console.Read();
        }
    }
}