﻿//////////////////////////////////////////////////////////////////////////
//多个代码数据事件驱动
//策略描述：
//策略订阅多个代码数据，触发策略

using GMSDK;

namespace MultiCodeDataEventDriven
{
    public class MyStrategy : Strategy
    {
        public MyStrategy(string token, string strategyId, StrategyMode mode) : base(token, strategyId, mode) { }

        //重写OnInit事件， 进行策略开发
        public override void OnInit()
        {
            System.Console.WriteLine("OnInit");

            //订阅浦发银行，bar频率为一天
            Subscribe("SHSE.600000,SZSE.000001", "1d");
            return;
        }

        //重写OnBar事件
        public override void OnBar(Bar bar)
        {
            System.Console.WriteLine("OnBar：");
            System.Console.WriteLine("{0, -50}{1}", "代码：", bar.symbol);
            System.Console.WriteLine("{0, -50}{1}", "bar的开始时间：", bar.bob);
            System.Console.WriteLine("{0, -50}{1}", "bar的结束时间：", bar.eob);
            System.Console.WriteLine("{0, -50}{1}", "开盘价：", bar.open);
            System.Console.WriteLine("{0, -50}{1}", "收盘价：", bar.close);
            System.Console.WriteLine("{0, -50}{1}", "最高价：", bar.high);
            System.Console.WriteLine("{0, -50}{1}", "最低价：", bar.low);
            System.Console.WriteLine("{0, -50}{1}", "成交量：", bar.volume);
            System.Console.WriteLine("{0, -50}{1}", "成交金额：", bar.amount);
            System.Console.WriteLine("{0, -50}{1}", "前收盘价：", bar.preClose);
            System.Console.WriteLine("{0, -50}{1}", "持仓量：", bar.position);
            System.Console.WriteLine("{0, -50}{1}", "bar频度：", bar.frequency);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            MyStrategy s = new MyStrategy("{{token}}","{{strategyId}}", StrategyMode.MODE_BACKTEST);
            s.SetBacktestConfig("2016-07-11 17:20:00", "2017-07-11 17:30:00");
            s.Run();
            System.Console.WriteLine("回测完成！");
            System.Console.Read();
        }
    }
}